Index: tmp/org.txm.setups/nsis/Include/Win/WinUser.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/Win/WinUser.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/Win/WinUser.nsh	(revision 2956)
@@ -87,17 +87,16 @@
 !endif
 
 !ifndef __WIN_MS_NOWINOFFSETS
-/* in nsDialogs.nsh...
-!define GWL_STYLE           -16
-!define GWL_EXSTYLE         -20 */
-!define GWLP_WNDPROC        -4
-!define GWLP_HINSTANCE      -6
-!define GWLP_HWNDPARENT     -8
-!define GWLP_USERDATA       -21
-!define GWLP_ID             -12
+!define /ifndef GWL_STYLE       -16
+!define /ifndef GWL_EXSTYLE     -20
+!define /ifndef GWLP_WNDPROC    -4
+!define /ifndef GWLP_HINSTANCE  -6
+!define /ifndef GWLP_HWNDPARENT -8
+!define /ifndef GWLP_USERDATA   -21
+!define /ifndef GWLP_ID         -12
 !define DWLP_MSGRESULT  0
-!define /math DWLP_DLGPROC    ${DWLP_MSGRESULT} + ${__WIN_PTRSIZE} ;DWLP_MSGRESULT + sizeof(LRESULT) 
-!define /math DWLP_USER       ${DWLP_DLGPROC} + ${__WIN_PTRSIZE} ;DWLP_DLGPROC + sizeof(DLGPROC)
+!define /math DWLP_DLGPROC ${DWLP_MSGRESULT} + ${NSIS_PTR_SIZE} ;DWLP_MSGRESULT + sizeof(LRESULT) 
+!define /math DWLP_USER    ${DWLP_DLGPROC} + ${NSIS_PTR_SIZE} ;DWLP_DLGPROC + sizeof(DLGPROC)
 !endif
 
 !ifndef __WIN_MS_NONCMESSAGES
@@ -155,40 +154,41 @@
 !define SC_SEPARATOR    0xF00F
 !endif
 
-!define IDC_ARROW       32512
-!define IDC_IBEAM       32513
-!define IDC_WAIT        32514
-!define IDC_CROSS       32515
-!define IDC_UPARROW     32516
-!define IDC_SIZENWSE    32642
-!define IDC_SIZENESW    32643
-!define IDC_SIZEWE      32644
-!define IDC_SIZENS      32645
-!define IDC_SIZEALL     32646
-!define IDC_NO          32648 
-!define IDC_HAND        32649
-!define IDC_APPSTARTING 32650 
-!define IDC_HELP        32651
+!define /ifndef IDC_ARROW       32512
+!define /ifndef IDC_IBEAM       32513
+!define /ifndef IDC_WAIT        32514
+!define /ifndef IDC_CROSS       32515
+!define /ifndef IDC_UPARROW     32516
+!define /ifndef IDC_SIZE        32640
+!define /ifndef IDC_ICON        32641
+!define /ifndef IDC_SIZENWSE    32642
+!define /ifndef IDC_SIZENESW    32643
+!define /ifndef IDC_SIZEWE      32644
+!define /ifndef IDC_SIZENS      32645
+!define /ifndef IDC_SIZEALL     32646
+!define /ifndef IDC_NO          32648 
+!define /ifndef IDC_HAND        32649
+!define /ifndef IDC_APPSTARTING 32650 
+!define /ifndef IDC_HELP        32651
 
-/* in nsDialogs.nsh...
-!define IMAGE_BITMAP 0
-!define IMAGE_ICON   1
-!define IMAGE_CURSOR 2*/
+!define /ifndef IMAGE_BITMAP        0
+!define /ifndef IMAGE_ICON          1
+!define /ifndef IMAGE_CURSOR        2
+!define /ifndef IMAGE_ENHMETAFILE   3
 
-/* in nsDialogs.nsh...
-!define LR_DEFAULTCOLOR     0x0000
-!define LR_MONOCHROME       0x0001
-!define LR_COLOR            0x0002
-!define LR_COPYRETURNORG    0x0004
-!define LR_COPYDELETEORG    0x0008
-!define LR_LOADFROMFILE     0x0010
-!define LR_LOADTRANSPARENT  0x0020
-!define LR_DEFAULTSIZE      0x0040
-!define LR_VGACOLOR         0x0080
-!define LR_LOADMAP3DCOLORS  0x1000
-!define LR_CREATEDIBSECTION 0x2000
-!define LR_COPYFROMRESOURCE 0x4000
-!define LR_SHARED           0x8000*/
+!define /ifndef LR_DEFAULTCOLOR     0x0000
+!define /ifndef LR_MONOCHROME       0x0001
+!define /ifndef LR_COLOR            0x0002
+!define /ifndef LR_COPYRETURNORG    0x0004
+!define /ifndef LR_COPYDELETEORG    0x0008
+!define /ifndef LR_LOADFROMFILE     0x0010
+!define /ifndef LR_LOADTRANSPARENT  0x0020
+!define /ifndef LR_DEFAULTSIZE      0x0040
+!define /ifndef LR_VGACOLOR         0x0080
+!define /ifndef LR_LOADMAP3DCOLORS  0x1000
+!define /ifndef LR_CREATEDIBSECTION 0x2000
+!define /ifndef LR_COPYFROMRESOURCE 0x4000
+!define /ifndef LR_SHARED           0x8000
 
 !define GA_PARENT    1
 !define GA_ROOT      2
Index: tmp/org.txm.setups/nsis/Include/WinCore.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/WinCore.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/WinCore.nsh	(revision 2956)
@@ -13,9 +13,7 @@
 !verbose 3
 
 
-!define __WIN_PTRSIZE 4 ;will we ever see a 64 bit version?
 
-
 !include Win\WinDef.nsh
 !include Win\WinError.nsh
 !include Win\WinNT.nsh
@@ -33,10 +31,10 @@
 WinBase.h
 **************************************************/
 !ifndef __WIN_NOINC_WINBASE
-!define INVALID_HANDLE_VALUE -1
-!define INVALID_FILE_SIZE 0xFFFFFFFF
-!define INVALID_SET_FILE_POINTER -1
-!define INVALID_FILE_ATTRIBUTES -1
+!define /ifndef INVALID_HANDLE_VALUE -1
+!define /ifndef INVALID_FILE_SIZE 0xFFFFFFFF
+!define /ifndef INVALID_SET_FILE_POINTER -1
+!define /ifndef INVALID_FILE_ATTRIBUTES -1
 
 !define WAIT_FAILED 0xFFFFFFFF
 !define WAIT_OBJECT_0       0 ;((STATUS_WAIT_0 ) + 0 )
@@ -210,5 +208,56 @@
 
 
 
+
+/**************************************************
+Shobjidl.h
+**************************************************/
+!ifndef __WIN_NOINC_SHOBJIDL
+; ASSOCIATIONLEVEL
+!define AL_MACHINE 0
+!define AL_EFFECTIVE 1
+!define AL_USER 2
+
+; ASSOCIATIONTYPE
+!define AT_FILEEXTENSION 0
+!define AT_URLPROTOCOL 1
+!define AT_STARTMENUCLIENT 2
+!define AT_MIMETYPE 3
+!endif /* __WIN_NOINC_SHOBJIDL */
+
+
+
+
+
+/**************************************************
+ShlGuid.h
+**************************************************/
+!ifndef __WIN_NOINC_SHLGUID
+!define FOLDERID_Public {DFDF76A2-C82A-4D63-906A-5644AC457385} ; Vista+ Fixed=%SystemDrive%\Users\Public
+!define FOLDERID_Games {CAC52C1A-B53D-4edc-92D7-6B2E8AC19434} ; Vista+ && < 10 (1803) Virtual
+!define FOLDERID_SavedGames {4C5C32FF-BB9D-43b0-B5B4-2D72E54EAAA4} ; Vista+ PerUser=%USERPROFILE%\Saved Games
+!define FOLDERID_GameTasks {054FAE61-4DD8-4787-80B6-090220C4B700} ; Vista+ PerUser=%LOCALAPPDATA%\Microsoft\Windows\GameExplorer
+!define FOLDERID_PublicGameTasks {DEBF2536-E1A8-4c59-B6A2-414586476AEA} ; Vista+ Common=%ALLUSERSPROFILE%\Microsoft\Windows\GameExplorer
+!define FOLDERID_Contacts {56784854-C6CB-462b-8169-88E350ACB882} ; Vista+ PerUser=%USERPROFILE%\Contacts
+!define FOLDERID_Downloads {374DE290-123F-4565-9164-39C4925E467B} ; Vista+ PerUser=%USERPROFILE%\Downloads
+!define FOLDERID_PublicDownloads {3D644C9B-1FB8-4f30-9B45-F670235F79C0} ; Vista+ Common=%PUBLIC%\Downloads
+!define FOLDERID_UserProfiles {0762D272-C50A-4BB0-A382-697DCD729B80} ; Vista+ Fixed=%SystemDrive%\Users
+!define FOLDERID_UserProgramFiles {5CD7AEE2-2219-4A67-B85D-6C9CE15660CB} ; 7+ PerUser=%LOCALAPPDATA%\Programs
+!define FOLDERID_UserProgramFilesCommon {BCBD3057-CA5C-4622-B42D-BC56DB0AE516} ; 7+ PerUser=%LOCALAPPDATA%\Programs\Common
+!define FOLDERID_PublicLibraries {48DAF80B-E6CF-4F4E-B800-0E69D84EE384} ; 7+ Common=%ALLUSERSPROFILE%\Microsoft\Windows\Libraries
+!define FOLDERID_UserPinned {9E3995AB-1F9C-4F13-B827-48B24B6C7174} ; 7+ PerUser=%APPDATA%\Microsoft\Internet Explorer\Quick Launch\User Pinned
+!define FOLDERID_ImplicitAppShortcuts {BCB5256F-79F6-4CEE-B725-DC34E402FD46} ; 7+ PerUser=%APPDATA%\Microsoft\Internet Explorer\Quick Launch\User Pinned\ImplicitAppShortcuts
+!define FOLDERID_DeviceMetadataStore {5CE4A5E9-E4EB-479D-B89F-130C02886155} ; 7+ Common=%ALLUSERSPROFILE%\Microsoft\Windows\DeviceMetadataStore
+!define FOLDERID_ApplicationShortcuts {A3918781-E5F2-4890-B3D9-A7E54332328C} ; 8.0+ PerUser=%LOCALAPPDATA%\Microsoft\Windows\Application Shortcuts
+!define FOLDERID_RoamingTiles {00BCFC5A-ED94-4e48-96A1-3F6217F21990} ; 8.0+ PerUser=%LOCALAPPDATA%\Microsoft\Windows\RoamingTiles
+!define FOLDERID_RoamedTileImages {AAA8D5A5-F1D6-4259-BAA8-78E7EF60835E} ; 8.0+ PerUser=%LOCALAPPDATA%\Microsoft\Windows\RoamedTileImages
+!define FOLDERID_PublicUserTiles {0482af6c-08f1-4c34-8c90-e17ec98b1e17} ; 8.0+ Common=%PUBLIC%\AccountPictures
+!define FOLDERID_AccountPictures {008ca0b1-55b4-4c56-b8a8-4de4b299d3be} ; 8.0+ PerUser=%APPDATA%\Microsoft\Windows\AccountPictures
+!define FOLDERID_Screenshots {b7bede81-df94-4682-a7d8-57a52620b86f} ; 8.0+ PerUser=%USERPROFILE%\Pictures\Screenshots
+!define FOLDERID_SkyDrive {A52BBA46-E9E1-435f-B3D9-28DAA648C0F6} ; 8.1+ PerUser=%USERPROFILE%\OneDrive
+!define FOLDERID_AppDataProgramData {559D40A3-A036-40FA-AF61-84CB430A4D34} ; 10 (1709)+ PerUser=%LOCALAPPDATA%\ProgramData
+!endif /* __WIN_NOINC_SHLGUID */
+
+
 !verbose pop
 !endif /* __WIN_WINDOWS__INC */
\ No newline at end of file
Index: tmp/org.txm.setups/nsis/Include/WinVer.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/WinVer.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/WinVer.nsh	(revision 2956)
@@ -12,11 +12,15 @@
 ;     DetailPrint "Not running on NT. Installing ANSI application."
 ;   ${EndIf}
 ;
-; IsServer checks if the installer is running on a server version of Windows (NT4, 2003, 2008, etc.)
+; IsServerOS checks if the installer is running on a server version of Windows (2000, 2003, 2008, etc.)
+; IsDomainController checks if the server is a domain controller
 ;
 ; AtLeastWin<version> checks if the installer is running on Windows version at least as specified.
 ; IsWin<version> checks if the installer is running on Windows version exactly as specified.
 ; AtMostWin<version> checks if the installer is running on Windows version at most as specified.
+; AtLeastBuild <number> checks if the installer is running on a Windows version with a minimum build number.
+; AtMostBuild <number> checks if the installer is running on a Windows version with a maximum build number.
+; AtLeastWaaS <name> and AtMostWaaS <name> checks Windows 10 "friendly names" against the build number.
 ;
 ; <version> can be replaced with the following values:
 ;
@@ -34,7 +38,12 @@
 ;   2008R2
 ;   8
 ;   2012
+;   8.1
+;   2012R2
+;   10
 ;
+;   Note: Windows 8.1 and later will be detected as Windows 8 unless ManifestSupportedOS is set correctly!
+;
 ; AtLeastServicePack checks if the installer is running on Windows service pack version at least as specified.
 ; IsServicePack checks if the installer is running on Windows service pack version exactly as specified.
 ; AtMostServicePack checks if the installer is running on Windows service version pack at most as specified.
@@ -73,7 +82,7 @@
 ;   check if running on the NT family.
 ;
 ;     ${If} ${AtLeastWin95}
-;     ${And} ${AtMostWinME}
+;     ${AndIf} ${AtMostWinME}
 ;       DetailPrint "Running 95, 98 or ME."
 ;       DetailPrint "Actually, maybe it's NT4?"
 ;       ${If} ${IsNT}
@@ -103,16 +112,16 @@
 
 # masks for our variables
 
-!define _WINVER_VERXBIT  0x00000001
-!define _WINVER_MASKVMAJ 0x7F000000
-!define _WINVER_MASKVMIN 0x00FF0000
+!define _WINVER_VERXBIT  0x00000001 ; Used to boost $__WINVERV
+!define _WINVER_MASKVMAJ 0x7F000000 ; $__WINVERV mask
+!define _WINVER_MASKVMIN 0x00FF0000 ; $__WINVERV mask
+!define _WINVER_NTMASK   0x7FFFFFFF ; $__WINVERV mask used by AtMost/AtLeast
+!define _WINVER_NTBIT    0x80000000 ; $__WINVERV bit used by Is and $__WINVERSP bit used by IsNT
+!define _WINVER_NTSRVBIT 0x40000000 ; $__WINVERSP bit for !VER_NT_WORKSTATION
+!define _WINVER_NTDCBIT  0x20000000 ; $__WINVERSP bit for VER_NT_DOMAIN_CONTROLLER
+!define _WINVER_MASKVBLD 0x0000FFFF ; $__WINVERSP mask for OS build number
+!define _WINVER_MASKSP   0x000F0000 ; $__WINVERSP mask for OS service pack
 
-!define _WINVER_NTBIT    0x80000000
-!define _WINVER_NTMASK   0x7FFFFFFF
-!define _WINVER_NTSRVBIT 0x40000000
-!define _WINVER_MASKVBLD 0x0000FFFF
-!define _WINVER_MASKSP   0x000F0000
-
 # possible variable values for different versions
 
 !define WINVER_95_NT     0x04000000 ;4.00.0950
@@ -122,7 +131,7 @@
 ;define WINVER_98SE      0x040a0000 ;4.10.2222
 !define WINVER_ME_NT     0x045a0000 ;4.90.3000
 !define WINVER_ME        0x045a0000 ;4.90.3000
-;define WINVER_NT3d51               ;3.51.1057
+;define WINVER_NT3.51               ;3.51.1057
 !define WINVER_NT4_NT    0x84000000 ;4.00.1381
 !define WINVER_NT4       0x04000000 ;4.00.1381
 !define WINVER_2000_NT   0x85000000 ;5.00.2195
@@ -144,23 +153,32 @@
 !define WINVER_8         0x06020000 ;6.02.9200
 !define WINVER_2012_NT   0x86020001 ;6.02.9200
 !define WINVER_2012      0x06020001 ;6.02.9200
+!define WINVER_8.1_NT    0x86030000 ;6.03.9600
+!define WINVER_8.1       0x06030000 ;6.03.9600
+!define WINVER_2012R2_NT 0x86030001 ;6.03.9600
+!define WINVER_2012R2    0x06030001 ;6.03.9600
+!define WINVER_10_NT     0x8A000000 ;10.0.10240
+!define WINVER_10        0x0A000000 ;10.0.10240
+!define WINVER_2016_NT   0x8A000001 ;10.0.14393
+!define WINVER_2016      0x0A000001 ;10.0.14393
 
 
 # use this to make all nt > 9x
 
 !ifdef WINVER_NT4_OVER_W95
-  !define __WINVERTMP ${WINVER_NT4}
-  !undef WINVER_NT4
-  !define /math WINVER_NT4 ${__WINVERTMP} | ${_WINVER_VERXBIT}
-  !undef __WINVERTMP
+  !define /redef /math WINVER_NT4 ${WINVER_NT4} | ${_WINVER_VERXBIT}
 !endif
 
 # some definitions from header files
 
+!define OSVERSIONINFOW_SIZE   276
+!define OSVERSIONINFOEXW_SIZE 284
 !define OSVERSIONINFOA_SIZE   148
 !define OSVERSIONINFOEXA_SIZE 156
-!define VER_PLATFORM_WIN32_NT 2
-!define VER_NT_WORKSTATION    1
+!define /ifndef VER_PLATFORM_WIN32_NT 2
+!define /ifndef VER_NT_WORKSTATION       1
+!define /ifndef VER_NT_DOMAIN_CONTROLLER 2
+!define /ifndef VER_NT_SERVER            3
 
 !define SM_TABLETPC    86
 !define SM_MEDIACENTER 87
@@ -189,7 +207,7 @@
   !macro __WinVer_Call_GetVersionEx STRUCT_SIZE
 
     System::Call '*$0(i ${STRUCT_SIZE})'
-    System::Call kernel32::GetVersionEx(ir0)i.r3
+    System::Call kernel32::GetVersionEx(pr0)i.r3
 
   !macroend
 
@@ -211,16 +229,24 @@
   Push $3 ;bld
   Push $R0 ;temp
 
+  # a plugin call will lock the Unicode mode, it is now safe to set the struct size
+  !ifdef NSIS_UNICODE
+  !define /redef OSVERSIONINFO_SIZE ${OSVERSIONINFOW_SIZE}
+  !define /redef OSVERSIONINFOEX_SIZE ${OSVERSIONINFOEXW_SIZE}
+  !else
+  !define /redef OSVERSIONINFO_SIZE ${OSVERSIONINFOA_SIZE}
+  !define /redef OSVERSIONINFOEX_SIZE ${OSVERSIONINFOEXA_SIZE}
+  !endif
+
   # allocate memory
-  System::Alloc ${OSVERSIONINFOEXA_SIZE}
-  Pop $0
+  System::Call '*(&i${OSVERSIONINFOEX_SIZE})p.r0'
 
   # use OSVERSIONINFOEX
-  !insertmacro __WinVer_Call_GetVersionEx ${OSVERSIONINFOEXA_SIZE}
+  !insertmacro __WinVer_Call_GetVersionEx ${OSVERSIONINFOEX_SIZE}
 
   IntCmp $3 0 "" _winver_ex _winver_ex
     # OSVERSIONINFOEX not allowed (Win9x or NT4 w/SP < 6), use OSVERSIONINFO
-    !insertmacro __WinVer_Call_GetVersionEx ${OSVERSIONINFOA_SIZE}
+    !insertmacro __WinVer_Call_GetVersionEx ${OSVERSIONINFO_SIZE}
   _winver_ex:
 
   # get results from struct
@@ -243,7 +269,8 @@
     IntOp $__WINVERSP $__WINVERSP | ${_WINVER_NTBIT}
     IntOp $__WINVERV  $__WINVERV  | ${_WINVER_NTBIT}
   _winver_notnt:
-
+!ifndef NSIS_UNICODE
+!if "${NSIS_PTR_SIZE}" <= 4
   # get service pack information
   IntCmp $0 ${VER_PLATFORM_WIN32_NT} _winver_nt "" _winver_nt  # win9x
 
@@ -271,9 +298,10 @@
     Goto _winver_sp_done
 
   _winver_nt: # nt
+!endif #~ 32-bit
+!endif #~ ANSI
+    IntCmp $R0 ${OSVERSIONINFOEX_SIZE} "" _winver_sp_noex _winver_sp_noex
 
-    IntCmp $R0 ${OSVERSIONINFOEXA_SIZE} "" _winver_sp_noex _winver_sp_noex
-
       # discard szCSDVersion
       Pop $0
 
@@ -282,9 +310,12 @@
       Pop $0
 
       # is server?
-      IntCmp $0 ${VER_NT_WORKSTATION} _winver_noserver _winver_noserver ""
+      IntCmp $0 ${VER_NT_WORKSTATION} _winver_nt_notsrv
         IntOp $__WINVERSP $__WINVERSP | ${_WINVER_NTSRVBIT}
-      _winver_noserver:
+        IntCmp $0 ${VER_NT_DOMAIN_CONTROLLER} "" _winver_nt_notdc _winver_nt_notdc
+          IntOp $__WINVERSP $__WINVERSP | ${_WINVER_NTDCBIT}
+        _winver_nt_notdc:
+      _winver_nt_notsrv:
 
       # get wServicePackMajor
       Pop $0
@@ -295,7 +326,7 @@
     _winver_sp_noex: # OSVERSIONINFO, not OSVERSIONINFOEX
 
       ####  TODO
-      ## For IsServer to support < NT4SP6, we need to check the registry
+      ## For IsServerOS to support < NT4SP6, we need to check the registry
       ## here to see if we are a server and/or DC
 
       # get szCSDVersion
@@ -313,7 +344,7 @@
         StrCpy $0 0 # no service pack
 
 !ifdef WINVER_NT4_OVER_W95
-      IntOp $__WINVERV $__WINVERV | ${_WINVER_VERXBIT}
+      IntOp $__WINVERV $__WINVERV | ${_WINVER_VERXBIT} ; change NT 4.0.reserved.0 to 4.0.reserved.1
 !endif
 
   _winver_sp_done:
@@ -395,6 +426,10 @@
   !insertmacro __WinVer_DefineOSTest ${Test} 2008R2 '${Suffix}'
   !insertmacro __WinVer_DefineOSTest ${Test} 8      '${Suffix}'
   !insertmacro __WinVer_DefineOSTest ${Test} 2012   '${Suffix}'
+  !insertmacro __WinVer_DefineOSTest ${Test} 8.1    '${Suffix}'
+  !insertmacro __WinVer_DefineOSTest ${Test} 2012R2 '${Suffix}'
+  !insertmacro __WinVer_DefineOSTest ${Test} 10     '${Suffix}'
+  !insertmacro __WinVer_DefineOSTest ${Test} 2016   '${Suffix}'
 !macroend
 
 !insertmacro __WinVer_DefineOSTests AtLeast ""
@@ -403,21 +438,16 @@
 
 # version feature LogicLib macros
 
-!macro _IsNT _a _b _t _f
+!macro __WinVer_LL_IsBitSet _v _b _t _f
   !insertmacro _LOGICLIB_TEMP
   ${CallArtificialFunction} __WinVer_InitVars
-  IntOp $_LOGICLIB_TEMP $__WINVERSP & ${_WINVER_NTBIT}
+  IntOp $_LOGICLIB_TEMP ${_v} & ${_b}
   !insertmacro _!= $_LOGICLIB_TEMP 0 `${_t}` `${_f}`
 !macroend
-!define IsNT `"" IsNT ""`
 
-!macro _IsServerOS _a _b _t _f
-  !insertmacro _LOGICLIB_TEMP
-  ${CallArtificialFunction} __WinVer_InitVars
-  IntOp $_LOGICLIB_TEMP $__WINVERSP & ${_WINVER_NTSRVBIT}
-  !insertmacro _!= $_LOGICLIB_TEMP 0 `${_t}` `${_f}`
-!macroend
-!define IsServerOS `"" IsServerOS ""`
+!define IsNT `$__WINVERSP _WinVer_LL_IsBitSet ${_WINVER_NTBIT}`
+!define IsServerOS `$__WINVERSP _WinVer_LL_IsBitSet ${_WINVER_NTSRVBIT}`
+!define IsDomainController `$__WINVERSP _WinVer_LL_IsBitSet ${_WINVER_NTDCBIT}`
 
 # service pack macros
 
@@ -481,8 +511,51 @@
 !define WinVerGetMinor '!insertmacro __WinVer_GetVer $__WINVERV  16 ${_WINVER_MASKVMIN}'
 !define WinVerGetBuild '!insertmacro __WinVer_GetVer $__WINVERSP "" ${_WINVER_MASKVBLD}'
 
-# done
+!macro _WinVer_BuildNumCheck op num _t _f
+  !insertmacro _LOGICLIB_TEMP
+  ${WinVerGetBuild} $_LOGICLIB_TEMP
+  !insertmacro _${op} $_LOGICLIB_TEMP ${num} `${_t}` `${_f}`
+!macroend
+!define AtLeastBuild `U>= WinVer_BuildNumCheck `
+!define AtMostBuild `U<= WinVer_BuildNumCheck `
 
+# Windows as a Service macros
+
+!macro WinVer_WaaS id build fu codename marketingname
+  !if "${id}" == ${fu}
+    !define WinVer_WaaS_Build ${build}
+  !else if "${id}" == "${codename}"
+    !define WinVer_WaaS_Build ${build}
+  !else if "${id}" == "${marketingname}"
+    !define WinVer_WaaS_Build ${build}
+  !endif
+!macroend
+
+!macro _WinVer_WaaS op id _t _f
+  !insertmacro WinVer_WaaS "${id}" 10240 1507 "Threshold"   "RTM" ; 10240.16384
+  !insertmacro WinVer_WaaS "${id}" 10586 1511 "Threshold 2" "November Update" ; 10586.0?
+  !insertmacro WinVer_WaaS "${id}" 14393 1607 "Redstone"    "Anniversary Update" ; 14393.10
+  !insertmacro WinVer_WaaS "${id}" 15063 1703 "Redstone 2"  "Creators Update" ; 15063.13
+  !insertmacro WinVer_WaaS "${id}" 16299 1709 "Redstone 3"  "Fall Creators Update" ; 16299.19
+  !insertmacro WinVer_WaaS "${id}" 17134 1803 "Redstone 4"  "April 2018 Update" ; 17134.1
+  !insertmacro WinVer_WaaS "${id}" 17763 1809 "Redstone 5"  "October 2018 Update" ; 17763.1
+  !insertmacro WinVer_WaaS "${id}" 18362 1903 "19H1"        "May 2019 Update" ; 18362.116
+  !insertmacro WinVer_WaaS "${id}" 18363 1909 "19H2"        "November 2019 Update" ; 18363.418
+  !insertmacro WinVer_WaaS "${id}" 19041 2004 "20H1"        "May 2020 Update" ; 19041.264?
+  !ifmacrodef WinVerExternal_WaaS_MapToBuild
+    !insertmacro WinVerExternal_WaaS_MapToBuild ${op} "${id}" WinVer_WaaS_Build
+  !endif
+  !define /IfNDef WinVer_WaaS_Build 0
+  !if "${WinVer_WaaS_Build}" <= 9600
+    !error 'WinVer: Unknown WaaS name: ${id}'
+  !endif
+  !insertmacro _WinVer_BuildNumCheck ${op} ${WinVer_WaaS_Build} `${_t}` `${_f}`
+  !undef WinVer_WaaS_Build
+!macroend
+
+!define AtLeastWaaS `U>= WinVer_WaaS `
+!define AtMostWaaS `U<= WinVer_WaaS `
+
 !endif # !___WINVER__NSH___
 
 !verbose pop
Index: tmp/org.txm.setups/nsis/Include/Util.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/Util.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/Util.nsh	(revision 2956)
@@ -4,53 +4,181 @@
 ;
 ; Voodoo macros to make end-user usage easier. This may be documented someday.
 
-!verbose push
-!verbose 3
-
+!verbose push 3
 !ifndef ___UTIL__NSH___
 !define ___UTIL__NSH___
 
-# see WinVer.nsh and *Func.nsh for usage examples
-!macro CallArtificialFunction NAME
-  !ifndef __UNINSTALL__
-    !define CallArtificialFunction_TYPE inst
-  !else
-    !define CallArtificialFunction_TYPE uninst
-  !endif
-  Call :.${NAME}${CallArtificialFunction_TYPE}
-  !ifndef ${NAME}${CallArtificialFunction_TYPE}_DEFINED
-    Goto ${NAME}${CallArtificialFunction_TYPE}_DONE
-    !define ${NAME}${CallArtificialFunction_TYPE}_DEFINED
-    .${NAME}${CallArtificialFunction_TYPE}:
+# CallArtificialFunction, see WinVer.nsh and *Func.nsh for usage examples
+!macro CallArtificialFunctionHelper TYPE NAME
+  !verbose pop
+  Call :.${NAME}${TYPE}
+  !ifndef ${NAME}${TYPE}_DEFINED
+    !verbose push 2
+    Goto ${NAME}${TYPE}_DONE
+    !define ${NAME}${TYPE}_DEFINED
+    !verbose pop
+    .${NAME}${TYPE}:
       !insertmacro ${NAME}
-    Return
-    ${NAME}${CallArtificialFunction_TYPE}_DONE:
+      Return
+    ${NAME}${TYPE}_DONE:
   !endif
-  !undef CallArtificialFunction_TYPE
+  !verbose push 2
 !macroend
-!define CallArtificialFunction `!insertmacro CallArtificialFunction`
 
-# for usage of artificial functions inside artificial functions
-# macro recursion is prohibited
-!macro CallArtificialFunction2 NAME
-  !ifndef __UNINSTALL__
-    !define CallArtificialFunction2_TYPE inst
+!macro CallArtificialFunction NAME
+  !verbose push 2
+  !ifdef __UNINSTALL__
+    !insertmacro CallArtificialFunctionHelper uninst ${NAME}
   !else
-    !define CallArtificialFunction2_TYPE uninst
+    !insertmacro CallArtificialFunctionHelper inst ${NAME}
   !endif
-  Call :.${NAME}${CallArtificialFunction2_TYPE}
-  !ifndef ${NAME}${CallArtificialFunction2_TYPE}_DEFINED
-    Goto ${NAME}${CallArtificialFunction2_TYPE}_DONE
-    !define ${NAME}${CallArtificialFunction2_TYPE}_DEFINED
-    .${NAME}${CallArtificialFunction2_TYPE}:
-      !insertmacro ${NAME}
-    Return
-    ${NAME}${CallArtificialFunction2_TYPE}_DONE:
-  !endif
-  !undef CallArtificialFunction2_TYPE
+  !verbose pop
 !macroend
-!define CallArtificialFunction2 `!insertmacro CallArtificialFunction2`
+!define CallArtificialFunction `!insertmacro CallArtificialFunction`
 
-!endif # !___UTIL__NSH___
+!macro CallArtificialFunction2 NAME ; Retained for v2.4x..v3.0b0 compatibility
+  ${CallArtificialFunction} ${NAME}
+!macroend
+!define CallArtificialFunction2 `!insertmacro CallArtificialFunction`
 
+
+!define Int32Op '!insertmacro Int32Op '
+!define Int64Op '!insertmacro Int64Op '
+!define IntPtrOp '!insertmacro IntPtrOp '
+!macro Int32Op r a o b
+IntOp `${r}` `${a}` `${o}` ${b}
+!macroend
+!macro Int64Op r a o b
+!echo "Int64Op ${r}=${a}${o}${b}"
+!verbose push 2
+System::Int64Op `${a}` `${o}` ${b}
+Pop ${r}
 !verbose pop
+!macroend
+!macro IntPtrOp r a o b
+IntPtrOp `${r}` `${a}` `${o}` `${b}`
+!macroend
+
+!define Int32Cmp '!insertmacro Int32Cmp '
+!define Int64Cmp '!insertmacro Int64Cmp '
+!define IntPtrCmp '!insertmacro IntPtrCmp '
+!macro Int32Cmp a b jeek jles jgtr
+IntCmp `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!macroend
+!macro Int64Cmp a b jeek jles jgtr
+!if ${NSIS_PTR_SIZE} <= 4
+!ifmacrondef _LOGICLIB_TEMP
+!include LogicLib.nsh
+!endif
+!echo "Int64Cmp ${a}:${b} =${jeek}, <${jles}, >${jgtr}"
+!verbose push 2
+${IfThen} ${a} L= ${b} ${|} Goto ${jeek} ${|}
+!insertmacro _L< ${a} ${b} `${jles}` `${jgtr}`
+!verbose pop
+!else
+Int64Cmp `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!endif
+!macroend
+!macro IntPtrCmp a b jeek jles jgtr
+IntPtrCmp `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!macroend
+
+!define Int32CmpU '!insertmacro Int32CmpU '
+!define Int64CmpU '!insertmacro Int64CmpU '
+!define IntPtrCmpU '!insertmacro IntPtrCmpU '
+!macro Int32CmpU a b jeek jles jgtr
+IntCmpU `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!macroend
+!macro Int64CmpUHelper
+; This macro performs "$_LOGICLIB_TEMP = a < b ? -1 : a > b ? 1 : 0" but System::Int64Op does not support unsigned operations so we have to perform multiple steps
+!ifmacrondef _LOGICLIB_TEMP
+!include LogicLib.nsh
+!endif
+!insertmacro _LOGICLIB_TEMP
+Exch $2 ; b
+Exch
+Exch $1 ; a
+; if (a == b) return 0;
+; if (a < 0)
+; {
+;   if (b >= 0) return 1
+; }
+; else
+; {
+;   if (b < 0) return -1
+; }
+; return a < b ? -1 : 1
+System::Int64Op $1 ^ $2 ; Using xor so $_LOGICLIB_TEMP ends up as 0 when they are equal
+Pop $_LOGICLIB_TEMP
+StrCmp $_LOGICLIB_TEMP 0 ret ; NOTE: Must use StrCmp, IntCmp fails on "0x8000000000000001 Z> 1"
+System::Int64Op $1 < 0
+Pop $_LOGICLIB_TEMP
+StrCmp $_LOGICLIB_TEMP 0 checkNegOther
+System::Int64Op $2 < 0 ; System::Int64Op does not support the >= operator so we invert the operation
+Pop $_LOGICLIB_TEMP
+StrCmp $_LOGICLIB_TEMP 0 retPos finalCmp
+retPos:
+StrCpy $_LOGICLIB_TEMP "1"
+Goto ret
+checkNegOther:
+System::Int64Op $2 < 0
+Pop $_LOGICLIB_TEMP
+StrCmp $_LOGICLIB_TEMP 0 finalCmp retNeg
+retNeg:
+StrCpy $_LOGICLIB_TEMP "-1"
+Goto ret
+finalCmp:
+System::Int64Op $1 < $2
+Pop $_LOGICLIB_TEMP
+StrCmp $_LOGICLIB_TEMP 0 retPos retNeg
+ret:
+Pop $1
+Pop $2
+!macroend
+!macro Int64CmpU a b jeek jles jgtr
+!if ${NSIS_PTR_SIZE} <= 4
+!echo "Int64CmpU ${a}:${b} =${jeek}, <${jles}, >${jgtr}"
+!verbose push 2
+Push `${a}`
+Push `${b}`
+!insertmacro CallArtificialFunction Int64CmpUHelper
+IntCmp $_LOGICLIB_TEMP 0 `${jeek}` `${jles}` `${jgtr}`
+!verbose pop
+!else
+Int64CmpU `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!endif
+!macroend
+!macro IntPtrCmpU a b jeek jles jgtr
+IntPtrCmpU `${a}` `${b}` `${jeek}` `${jles}` `${jgtr}`
+!macroend
+
+
+!define MakeARPInstallDate "!insertmacro MakeARPInstallDate "
+!macro MakeARPInstallDate _outvar
+System::Call 'KERNEL32::GetDateFormat(i0x409,i0,p0,t"yyyyMMdd",t.s,i${NSIS_MAX_STRLEN})'
+Pop ${_outvar}
+!macroend
+
+
+!define /IfNDef SPI_GETHIGHCONTRAST 0x42
+!define /IfNDef HCF_HIGHCONTRASTON 0x01
+!define /IfNDef /math SYSSIZEOF_HIGHCONTRAST 8 + ${NSIS_PTR_SIZE}
+!define IsHighContrastModeActive '"" IsHighContrastModeActive ""'
+!macro _IsHighContrastModeActive _lhs _rhs _t _f
+!ifmacrondef _LOGICLIB_TEMP
+!include LogicLib.nsh
+!endif
+!insertmacro _LOGICLIB_TEMP
+Push $1
+System::Call '*(i${SYSSIZEOF_HIGHCONTRAST},i0,p)p.r1'
+System::Call 'USER32::SystemParametersInfo(i${SPI_GETHIGHCONTRAST},i${SYSSIZEOF_HIGHCONTRAST},pr1,i0)'
+System::Call '*$1(i,i.s)'
+Pop $_LOGICLIB_TEMP
+System::Free $1
+Pop $1
+!insertmacro _& $_LOGICLIB_TEMP ${HCF_HIGHCONTRASTON} `${_t}` `${_f}`
+!macroend
+
+
+!endif # !___UTIL__NSH___
+!verbose pop
Index: tmp/org.txm.setups/nsis/Include/x64.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/x64.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/x64.nsh	(revision 2956)
@@ -4,20 +4,42 @@
 ;
 ; A few simple macros to handle installations on x64 machines.
 ;
-; RunningX64 checks if the installer is running on x64.
+; RunningX64 checks if the installer is running on a 64-bit OS.
+; IsWow64 checks if the installer is a 32-bit application running on a 64-bit OS.
 ;
 ;   ${If} ${RunningX64}
-;     MessageBox MB_OK "running on x64"
+;     MessageBox MB_OK "Running on 64-bit Windows"
 ;   ${EndIf}
 ;
+; IsNative* checks the OS native CPU architecture.
+;
+;   ${If} ${IsNativeAMD64}
+;     ; Install AMD64 64-bit driver/library
+;   ${ElseIf} ${IsNativeARM64}
+;     ; Install ARM64 64-bit driver/library
+;   ${ElseIf} ${IsNativeIA32}
+;     ; Install i386 32-bit driver/library
+;   ${Else}
+;     Abort "Unsupported CPU architecture!"
+;   ${EndIf}
+;
+;   ${If} ${IsNativeAMD64}
+;       File "amd64\myapp.exe"
+;   ${ElseIf} ${IsNativeIA32}
+;   ${OrIf} ${IsWow64}
+;       File "x86\myapp.exe"
+;   ${Else}
+;       Abort "Unsupported CPU architecture!"
+;   ${EndIf}
+;
 ; DisableX64FSRedirection disables file system redirection.
 ; EnableX64FSRedirection enables file system redirection.
 ;
 ;   SetOutPath $SYSDIR
 ;   ${DisableX64FSRedirection}
-;   File some.dll # extracts to C:\Windows\System32
+;   File something.bin # extracts to C:\Windows\System32
 ;   ${EnableX64FSRedirection}
-;   File some.dll # extracts to C:\Windows\SysWOW64
+;   File something.bin # extracts to C:\Windows\SysWOW64
 ;
 
 !ifndef ___X64__NSH___
@@ -25,30 +47,74 @@
 
 !include LogicLib.nsh
 
-!macro _RunningX64 _a _b _t _f
+
+!define IsWow64 `"" IsWow64 ""`
+!macro _IsWow64 _a _b _t _f
   !insertmacro _LOGICLIB_TEMP
-  System::Call kernel32::GetCurrentProcess()i.s
-  System::Call kernel32::IsWow64Process(is,*i.s)
+  System::Call kernel32::GetCurrentProcess()p.s
+  System::Call kernel32::IsWow64Process2(ps,*i0s,*i) ; [Win10.1511+] 0 if not WOW64
+  Push |
+  System::Call kernel32::IsWow64Process(p-1,*i0s) ; [WinXP+] FALSE for a 32-bit application on ARM64!
+  System::Int64Op
   Pop $_LOGICLIB_TEMP
   !insertmacro _!= $_LOGICLIB_TEMP 0 `${_t}` `${_f}`
 !macroend
 
+
 !define RunningX64 `"" RunningX64 ""`
+!macro _RunningX64 _a _b _t _f 
+  !if ${NSIS_PTR_SIZE} > 4
+    !insertmacro LogicLib_JumpToBranch `${_t}` `${_f}`
+  !else
+    !insertmacro _IsWow64 `${_a}` `${_b}` `${_t}` `${_f}`
+  !endif
+!macroend
 
-!macro DisableX64FSRedirection
 
-  System::Call kernel32::Wow64EnableWow64FsRedirection(i0)
+!define GetNativeMachineArchitecture "!insertmacro GetNativeMachineArchitecture "
+!macro GetNativeMachineArchitecture outvar
+  !define GetNativeMachineArchitecture_lbl lbl_GNMA_${__COUNTER__}
+  System::Call kernel32::GetCurrentProcess()p.s
+  System::Call kernel32::IsWow64Process2(ps,*i,*i0s)
+  Pop ${outvar}
+  IntCmp ${outvar} 0 "" ${GetNativeMachineArchitecture_lbl}_done ${GetNativeMachineArchitecture_lbl}_done
+    !if "${NSIS_PTR_SIZE}" <= 4
+    !if "${NSIS_CHAR_SIZE}" <= 1
+    System::Call 'USER32::CharNextW(w"")p.s'
+    Pop ${outvar}
+    IntPtrCmpU ${outvar} 0 "" ${GetNativeMachineArchitecture_lbl}_oldnt ${GetNativeMachineArchitecture_lbl}_oldnt
+      StrCpy ${outvar} 332 ; Always IMAGE_FILE_MACHINE_I386 on Win9x
+      Goto ${GetNativeMachineArchitecture_lbl}_done
+    ${GetNativeMachineArchitecture_lbl}_oldnt:
+    !endif
+    !endif
+    System::Call '*0x7FFE002E(&i2.s)'
+    Pop ${outvar}
+  ${GetNativeMachineArchitecture_lbl}_done:
+  !undef GetNativeMachineArchitecture_lbl
+!macroend
 
+!macro _IsNativeMachineArchitecture _ignore _arc _t _f
+  !insertmacro _LOGICLIB_TEMP
+  ${GetNativeMachineArchitecture} $_LOGICLIB_TEMP
+  !insertmacro _= $_LOGICLIB_TEMP ${_arc} `${_t}` `${_f}`
 !macroend
 
+!define IsNativeMachineArchitecture `"" IsNativeMachineArchitecture `
+!define IsNativeIA32 '${IsNativeMachineArchitecture} 332' ; Intel x86
+!define IsNativeAMD64 '${IsNativeMachineArchitecture} 34404' ; x86-64/x64
+!define IsNativeARM64 '${IsNativeMachineArchitecture} 43620'
+
+
 !define DisableX64FSRedirection "!insertmacro DisableX64FSRedirection"
+!macro DisableX64FSRedirection
+  System::Call kernel32::Wow64EnableWow64FsRedirection(i0)
+!macroend
 
+!define EnableX64FSRedirection "!insertmacro EnableX64FSRedirection"
 !macro EnableX64FSRedirection
-
   System::Call kernel32::Wow64EnableWow64FsRedirection(i1)
-
 !macroend
 
-!define EnableX64FSRedirection "!insertmacro EnableX64FSRedirection"
 
 !endif # !___X64__NSH___
